1
0
mirror of https://review.coreboot.org/flashrom.git synced 2025-04-26 22:52:34 +02:00

Convert flashrom to git

- Drop support for Subversion in the getrevision script and Makefile.
 - Add .gitignore and .gitattributes file (the latter to limit exports).
 - Restore modification dates of the exported files from the SCM.
 - Stop exporting SCM log dumps to CHANGELOG. This makes no sense.
 - Do not export the pre-"compiled" manpage. It can be generated like
   anything else from the code dump when we export the respective
   variable.
   The latter is added with this change.
 - Add some initial client-side git hooks
   * When committing check for obvious stuff you never want anyway:
     - white space errors
   * When pushing to the upstream repository check mandatory rules:
      - existing signoffs and acks in all new commits
      - no deletions or creation of branches
      - do not rewrite history of the precious branches, even if forced

NOTE: This patch is adapted from Stefan Tauner's original commit:
https://mail.coreboot.org/pipermail/flashrom/2016-November/014877.html

There are a few major differences:
- This uses coreboot's commit-msg hook which includes support for
  generating and appending Change-Id.
- djgpp-dos target removal is moved to a follow-up patch.
- Version string changes are moved to a follow-up patch.

Change-Id: I64eef21982cac0a0a7419bcd2c8a936672ae9cb2
Signed-off-by: Stefan Tauner <stefan.tauner@alumni.tuwien.ac.at>
Signed-off-by: David Hendricks <dhendricks@fb.com>
Reviewed-on: https://review.coreboot.org/19206
Reviewed-by: Nico Huber <nico.h@gmx.de>
Reviewed-by: Philippe Mathieu-Daudé <f4bug@amsat.org>
Tested-by: build bot (Jenkins) <no-reply@coreboot.org>
This commit is contained in:
Stefan Tauner 2016-11-27 17:45:49 +01:00 committed by David Hendricks
parent 8624e8cfa8
commit 7634708c98
12 changed files with 404 additions and 123 deletions

5
.gitattributes vendored Normal file
View File

@ -0,0 +1,5 @@
.gitattributes export-ignore
.gitignore export-ignore
/util/getrevision.sh export-ignore
/util/git-hooks export-ignore
/util/git-hooks/** export-ignore

15
.gitignore vendored Normal file
View File

@ -0,0 +1,15 @@
*.d
*.o
/.features
/.dependencies
/.libdeps
/build_details.txt
/flashrom
/flashrom-*
/flashrom.exe
/flashrom.8
/util/ich_descriptors_tool/ich_descriptors_tool
/util/ich_descriptors_tool/ich_descriptors_tool.exe
/util/ich_descriptors_tool/.dep
/util/ich_descriptors_tool/.obj

View File

@ -526,23 +526,36 @@ LIB_OBJS = libflashrom.o layout.o flashrom.o udelay.o programmer.o helpers.o ich
CLI_OBJS = cli_classic.o cli_output.o cli_common.o print.o
# Set the flashrom version string from the highest revision number of the checked out flashrom files.
# Note to packagers: Any tree exported with "make export" or "make tarball"
# will not require subversion. The downloadable snapshots are already exported.
SVNVERSION := $(shell ./util/getrevision.sh -u 2>/dev/null )
# Makefile.version is used when packaging flashrom and is generated by the
# export rule. If Makefile.version is not found, version info will be obtained
# using util/getrevision.sh or "unknown" if SCM metadata directory isn't found.
ifeq ($(wildcard Makefile.version),)
ifeq ($(wildcard .git),)
VERSION ?= unknown
MAN_DATE ?= unknown
else
VERSION ?= $(shell ./util/getrevision.sh --local)
MAN_DATE ?= $(shell ./util/getrevision.sh -d $(PROGRAM).8.tmpl 2>/dev/null)
# This is also a convenient time to install hooks.
$(shell ./util/git-hooks/install.sh)
endif
else
include Makefile.version
endif
RELEASE := 0.9.9
VERSION := $(RELEASE)-$(SVNVERSION)
RELEASENAME ?= $(VERSION)
# VERSION equals "offline" if online access is required but the respective git
# config variable is not set yet.
ifeq ($(VERSION),offline)
$(error Aborting)
endif
SVNDEF := -D'FLASHROM_VERSION="$(VERSION)"'
SCMDEF := -D'FLASHROM_VERSION="$(VERSION)"'
# Inform user if there is no meaningful version string. If there is version information from a VCS print
# something anyway because $(info...) will print a line break in any case which would look suspicious.
# The && between the echos is a workaround for old versions of GNU make that issue the error "unterminated
# variable reference" if a semicolon is used instead.
$(info $(shell ./util/getrevision.sh -c 2>/dev/null || echo "Files don't seem to be under version control." && \
echo "Replacing all version templates with $(VERSION)." ))
# No spaces in release names unless set explicitly
RELEASENAME ?= $(shell echo "$(VERSION)" | sed -e 's/ /_/')
# Inform user of the version string
$(info Replacing all version templates with $(VERSION).)
###############################################################################
# Default settings of CONFIG_* variables.
@ -1027,7 +1040,7 @@ libflashrom.a: $(LIBFLASHROM_OBJS)
TAROPTIONS = $(shell LC_ALL=C tar --version|grep -q GNU && echo "--owner=root --group=root")
%.o: %.c .features
$(CC) -MMD $(CFLAGS) $(CPPFLAGS) $(FLASHROM_CFLAGS) $(FEATURE_CFLAGS) $(SVNDEF) -o $@ -c $<
$(CC) -MMD $(CFLAGS) $(CPPFLAGS) $(FLASHROM_CFLAGS) $(FEATURE_CFLAGS) $(SCMDEF) -o $@ -c $<
# Make sure to add all names of generated binaries here.
# This includes all frontends and libflashrom.
@ -1371,7 +1384,7 @@ $(PROGRAM).8.html: $(PROGRAM).8
$(PROGRAM).8: $(PROGRAM).8.tmpl
@# Add the man page change date and version to the man page
@sed -e 's#.TH FLASHROM 8 ".*".*#.TH FLASHROM 8 "$(shell ./util/getrevision.sh -d $(PROGRAM).8.tmpl 2>/dev/null)" "$(VERSION)"#' <$< >$@
@sed -e 's#.TH FLASHROM 8 ".*".*#.TH FLASHROM 8 "$(MAN_DATE)" "$(VERSION)"#' <$< >$@
install: $(PROGRAM)$(EXEC_SUFFIX) $(PROGRAM).8
mkdir -p $(DESTDIR)$(PREFIX)/sbin
@ -1385,25 +1398,42 @@ libinstall: libflashrom.a libflashrom.h
mkdir -p $(DESTDIR)$(PREFIX)/include
$(INSTALL) -m 0644 libflashrom.h $(DESTDIR)$(PREFIX)/include
export: $(PROGRAM).8
@rm -rf $(EXPORTDIR)/flashrom-$(RELEASENAME)
@svn export -r BASE . $(EXPORTDIR)/flashrom-$(RELEASENAME)
@sed "s/^SVNVERSION.*/SVNVERSION := $(SVNVERSION)/" Makefile >$(EXPORTDIR)/flashrom-$(RELEASENAME)/Makefile
@cp $(PROGRAM).8 "$(EXPORTDIR)/flashrom-$(RELEASENAME)/$(PROGRAM).8"
@svn log >$(EXPORTDIR)/flashrom-$(RELEASENAME)/ChangeLog
@echo Exported $(EXPORTDIR)/flashrom-$(RELEASENAME)/
_export: $(PROGRAM).8
@rm -rf "$(EXPORTDIR)/flashrom-$(RELEASENAME)"
@mkdir -p "$(EXPORTDIR)/flashrom-$(RELEASENAME)"
@git archive HEAD | tar -x -C "$(EXPORTDIR)/flashrom-$(RELEASENAME)"
# Generate Makefile.version since SCM metadata won't be available in
# exported sources.
@echo "VERSION = $(VERSION)" > "$(EXPORTDIR)/flashrom-$(RELEASENAME)/Makefile.version"
@echo "MAN_DATE = $(MAN_DATE)" >> "$(EXPORTDIR)/flashrom-$(RELEASENAME)/Makefile.version"
# Restore modification date of all tracked files not marked
# 'export-ignore' in .gitattributes. sed is required to filter out file
# names having the attribute set.
@git ls-tree -r -z -t --full-name --name-only HEAD | \
git check-attr -z --stdin export-ignore | \
sed -zne 'x;n;n;/^set$$/{b};x;p' | \
xargs -0 sh -c 'for f; do \
touch -d $$(git log --pretty=format:%cI -1 HEAD -- "$$f") \
"$(EXPORTDIR)/flashrom-$(RELEASENAME)/$$f"; \
done'
tarball: export
@tar cjf $(EXPORTDIR)/flashrom-$(RELEASENAME).tar.bz2 -C $(EXPORTDIR)/ $(TAROPTIONS) flashrom-$(RELEASENAME)/
@rm -rf $(EXPORTDIR)/flashrom-$(RELEASENAME)
@echo Created $(EXPORTDIR)/flashrom-$(RELEASENAME).tar.bz2
export: _export
@echo "Exported $(EXPORTDIR)/flashrom-$(RELEASENAME)/"
tarball: _export
@tar -cz --format=ustar -f "$(EXPORTDIR)/flashrom-$(RELEASENAME).tar.gz" \
-C "$(EXPORTDIR)/$(TAROPTIONS)" "flashrom-$(RELEASENAME)/"
# Delete the exported directory again because it is most likely what's expected by the user.
@rm -rf "$(EXPORTDIR)/flashrom-$(RELEASENAME)"
@echo Created "$(EXPORTDIR)/flashrom-$(RELEASENAME).tar.gz"
djgpp-dos: clean
make CC=i586-pc-msdosdjgpp-gcc STRIP=i586-pc-msdosdjgpp-strip
libpayload: clean
make CC="CC=i386-elf-gcc lpgcc" AR=i386-elf-ar RANLIB=i386-elf-ranlib
.PHONY: all install clean distclean compiler hwlibs features export tarball djgpp-dos featuresavailable libpayload
.PHONY: all install clean distclean compiler hwlibs features _export export tarball featuresavailable libpayload
# Disable implicit suffixes and built-in rules (for performance and profit)
.SUFFIXES:

View File

@ -2030,7 +2030,7 @@ void print_buildinfo(void)
void print_version(void)
{
msg_ginfo("flashrom v%s", flashrom_version);
msg_ginfo("flashrom %s", flashrom_version);
print_sysinfo();
msg_ginfo("\n");
}

View File

@ -5,7 +5,7 @@
# Copyright (C) 2005 coresystems GmbH <stepan@coresystems.de>
# Copyright (C) 2009,2010 Carl-Daniel Hailfinger
# Copyright (C) 2010 Chromium OS Authors
# Copyright (C) 2013 Stefan Tauner
# Copyright (C) 2013-2016 Stefan Tauner
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
@ -31,30 +31,24 @@ export LC_ALL=C
export TZ=UTC0
# Helper functions
# First argument is the path to inspect (usually optional; w/o it the whole repository will be considered)
svn_has_local_changes() {
svn status "$1" | egrep '^ *[ADMR] *' >/dev/null
}
# First argument is the path to inspect (usually optional; without
# it the whole repository will be considered)
git_has_local_changes() {
git update-index -q --refresh >/dev/null
! git diff-index --quiet HEAD -- "$1"
}
git_last_commit() {
# git rev-parse --short HEAD would suffice if repository as a whole is of interest (no $1)
git log --pretty=format:"%h" -1 -- "$1"
}
svn_is_file_tracked() {
svn info "$1" >/dev/null 2>&1
}
git_is_file_tracked() {
git ls-files --error-unmatch -- "$1" >/dev/null 2>&1
}
is_file_tracked() {
svn_is_file_tracked "$1" || git_is_file_tracked "$1"
git_is_file_tracked "$1"
}
# Tries to find a remote source for the changes committed locally.
@ -62,7 +56,7 @@ is_file_tracked() {
# Takes one optional argument: the path to inspect
git_url() {
last_commit=$(git_last_commit "$1")
# get all remote branches containing the last commit (excluding origin/HEAD and git-svn branches/tags)
# get all remote branches containing the last commit (excluding origin/HEAD)
branches=$(git branch -r --contains $last_commit | sed '/\//!d;/.*->.*/d;s/[\t ]*//')
if [ -z "$branches" ] ; then
echo "No remote branch contains a suitable commit">&2
@ -89,13 +83,7 @@ git_url() {
scm_url() {
local url=
# for a primitive VCS like subversion finding the URL is easy: there is only one upstream host
if svn_is_file_tracked "$1" ; then
url="$(svn info "$1" 2>/dev/null |
grep URL: |
sed 's/.*URL:[[:blank:]]*//;s/:\/\/.*@/:\/\//' |
grep ^.)"
elif git_is_file_tracked "$1" ; then
if git_is_file_tracked "$1" ; then
url="$(git_url "$1")"
else
return ${EXIT_FAILURE}
@ -116,29 +104,7 @@ timestamp() {
# freebsd date [-jnu] [-d dst] [-r seconds] [-f fmt date | [[[[[cc]yy]mm]dd]HH]MM[.ss]] [+format] [...]
# dragonflybsd date [-jnu] [-d dst] [-r seconds] [-f fmt date | [[[[[cc]yy]mm]dd]HH]MM[.ss]] [+format] [...]
# openbsd date [-aju] [-d dst] [-r seconds] [+format] [[[[[[cc]yy]mm]dd]HH]MM[.SS]] [...]
if svn_is_file_tracked "$2" ; then
if svn_has_local_changes "$2"; then
t=$(date -u "$1")
else
# No local changes, get date of the last log record. Subversion provides that in
# ISO 8601 format when using the --xml switch. The sed call extracts that ignoring any
# fractional parts started by a comma or a dot.
local last_commit_date="$(svn info --xml "$2"| \
sed -n -e 's/<date>\([^,\.]*\)\([\.,].*\)*Z<\/date>/\1Z/p')"
case $(uname) in
# Most BSD dates do not support parsing date values from user input with -d but all of
# them support parsing the syntax with [[[[[[cc]yy]mm]dd]HH]MM[.ss]]. We have to
# transform the ISO8601 date first though.
NetBSD|OpenBSD|DragonFly|FreeBSD)
last_commit_date="$(echo ${last_commit_date} | \
sed -n -e 's/\(....\)-\(..\)-\(..\)T\(..\):\(..\):\(..\)Z/\1\2\3\4\5\.\6/p')"
t=$(date -u -j "${last_commit_date}" "$1" 2>/dev/null);;
*)
t=$(date -u -d "${last_commit_date}" "$1" 2>/dev/null);;
esac
fi
elif git_is_file_tracked "$2" ; then
if git_is_file_tracked "$2" ; then
# are there local changes?
if git_has_local_changes "$2" ; then
t=$(date -u "${1}")
@ -163,24 +129,10 @@ timestamp() {
echo "${t}"
}
# Retrieve local SCM revision info. This is useful if we're working in a different SCM than upstream and/or
# have local changes.
# Retrieve local revision info.
local_revision() {
local r=
if svn_is_file_tracked "$1" ; then
r=$(svn_has_local_changes "$1" && echo "dirty")
elif git_is_file_tracked "$1" ; then
r=$(git_last_commit "$1")
local svn_base=$(git log --grep=git-svn-id -1 --format='%h')
if [ "$svn_base" != "" ] ; then
local diff_to_svn=$(git rev-list --count ${svn_base}..${r})
if [ "$diff_to_svn" -gt 0 ] ; then
r="$r-$diff_to_svn"
fi
fi
if git_is_file_tracked "$1" ; then
local r=$(git describe $(git_last_commit "$1"))
if git_has_local_changes "$1" ; then
r="$r-dirty"
fi
@ -191,30 +143,6 @@ local_revision() {
echo "${r}"
}
# Get the upstream flashrom revision stored in SVN metadata.
upstream_revision() {
local r=
if svn_is_file_tracked "$1" ; then
r=$(svn info "$1" 2>/dev/null | \
grep "Last Changed Rev:" | \
sed -e "s/^Last Changed Rev: *//" -e "s/\([0-9]*\).*/r\1/" | \
grep "r[0-9]")
elif git_is_file_tracked "$1" ; then
# If this is a "native" git-svn clone we could use git svn log:
# git svn log --oneline -1 | sed 's/^r//;s/[[:blank:]].*//' or even git svn find-rev
# but it is easier to just grep for the git-svn-id unconditionally
r=$(git log --grep=git-svn-id -1 -- "$1" | \
grep git-svn-id | \
sed 's/.*@/r/;s/[[:blank:]].*//')
fi
if [ -z "$r" ]; then
r="unknown" # default to unknown
fi
echo "${r}"
}
is_tracked() {
is_file_tracked "$1"
}
@ -230,8 +158,6 @@ Commands
test if path is under version control at all
-l or --local
local revision information including an indicator for uncommitted changes
-u or --upstream
upstream revision
-U or --url
URL associated with the latest commit
-d or --date
@ -264,10 +190,6 @@ main() {
check_action $1
action=local_revision
shift;;
-u|--upstream)
check_action $1
action=upstream_revision
shift;;
-U|--url)
check_action $1
action=scm_url
@ -281,8 +203,8 @@ main() {
action="timestamp +%Y-%m-%dT%H:%M:%SZ" # There is only one valid time format! ISO 8601
shift;;
-c|--check)
check_action=$1
action="is_tracked"
check_action $1
action=is_tracked
shift;;
-*)
show_help;
@ -306,9 +228,6 @@ main() {
if [ -z "$query_path" ] ; then
query_path=.
fi
if ! is_file_tracked "$query_path" ; then
echo "Warning: Path \"${query_path}\" is not under version control.">&2
fi
if [ -z "$action" ] ; then
show_help
echo "Error: No actions specified"

15
util/git-hooks/applypatch-msg Executable file
View File

@ -0,0 +1,15 @@
#!/bin/sh
#
# A hook script to check the commit log message taken by
# applypatch from an e-mail message (via git-am).
# We simply do the same as for other commit messages
#
# The hook should exit with non-zero status after issuing an
# appropriate message if it wants to stop the commit. The hook is
# allowed to edit the commit message file.
#
. git-sh-setup
test -x "$GIT_DIR/hooks/commit-msg" &&
exec "$GIT_DIR/hooks/commit-msg" ${1+"$@"}
:

173
util/git-hooks/commit-msg Executable file
View File

@ -0,0 +1,173 @@
#!/bin/sh
#
# Part of Gerrit Code Review (http://code.google.com/p/gerrit/)
#
# Copyright (C) 2009 The Android Open Source Project
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#
CHANGE_ID_AFTER="Bug|Issue"
MSG="$1"
# Check for, and add if missing, a unique Change-Id
#
add_ChangeId() {
clean_message=`sed -e '
/^diff --git a\/.*/{
s///
q
}
/^Signed-off-by:/d
/^#/d
' "$MSG" | git stripspace`
if test -z "$clean_message"
then
return
fi
# Does Change-Id: already exist? if so, exit (no change).
if grep -i '^Change-Id: I[0-9a-f]\{40\}$' "$MSG" >/dev/null
then
return
fi
id=`_gen_ChangeId`
T="$MSG.tmp.$$"
AWK=awk
if [ -x /usr/xpg4/bin/awk ]; then
# Solaris AWK is just too broken
AWK=/usr/xpg4/bin/awk
fi
# How this works:
# - parse the commit message as (textLine+ blankLine*)*
# - assume textLine+ to be a footer until proven otherwise
# - exception: the first block is not footer (as it is the title)
# - read textLine+ into a variable
# - then count blankLines
# - once the next textLine appears, print textLine+ blankLine* as these
# aren't footer
# - in END, the last textLine+ block is available for footer parsing
$AWK '
BEGIN {
# while we start with the assumption that textLine+
# is a footer, the first block is not.
isFooter = 0
footerComment = 0
blankLines = 0
}
# Skip lines starting with "#" without any spaces before it.
/^#/ { next }
# Skip the line starting with the diff command and everything after it,
# up to the end of the file, assuming it is only patch data.
# If more than one line before the diff was empty, strip all but one.
/^diff --git a/ {
blankLines = 0
while (getline) { }
next
}
# Count blank lines outside footer comments
/^$/ && (footerComment == 0) {
blankLines++
next
}
# Catch footer comment
/^\[[a-zA-Z0-9-]+:/ && (isFooter == 1) {
footerComment = 1
}
/]$/ && (footerComment == 1) {
footerComment = 2
}
# We have a non-blank line after blank lines. Handle this.
(blankLines > 0) {
print lines
for (i = 0; i < blankLines; i++) {
print ""
}
lines = ""
blankLines = 0
isFooter = 1
footerComment = 0
}
# Detect that the current block is not the footer
(footerComment == 0) && (!/^\[?[a-zA-Z0-9-]+:/ || /^[a-zA-Z0-9-]+:\/\//) {
isFooter = 0
}
{
# We need this information about the current last comment line
if (footerComment == 2) {
footerComment = 0
}
if (lines != "") {
lines = lines "\n";
}
lines = lines $0
}
# Footer handling:
# If the last block is considered a footer, splice in the Change-Id at the
# right place.
# Look for the right place to inject Change-Id by considering
# CHANGE_ID_AFTER. Keys listed in it (case insensitive) come first,
# then Change-Id, then everything else (eg. Signed-off-by:).
#
# Otherwise just print the last block, a new line and the Change-Id as a
# block of its own.
END {
unprinted = 1
if (isFooter == 0) {
print lines "\n"
lines = ""
}
changeIdAfter = "^(" tolower("'"$CHANGE_ID_AFTER"'") "):"
numlines = split(lines, footer, "\n")
for (line = 1; line <= numlines; line++) {
if (unprinted && match(tolower(footer[line]), changeIdAfter) != 1) {
unprinted = 0
print "Change-Id: I'"$id"'"
}
print footer[line]
}
if (unprinted) {
print "Change-Id: I'"$id"'"
}
}' "$MSG" > $T && mv $T "$MSG" || rm -f $T
}
_gen_ChangeIdInput() {
echo "tree `git write-tree`"
if parent=`git rev-parse "HEAD^0" 2>/dev/null`
then
echo "parent $parent"
fi
echo "author `git var GIT_AUTHOR_IDENT`"
echo "committer `git var GIT_COMMITTER_IDENT`"
echo
printf '%s' "$clean_message"
}
_gen_ChangeId() {
_gen_ChangeIdInput |
git hash-object -t commit --stdin
}
add_ChangeId

19
util/git-hooks/install.sh Executable file
View File

@ -0,0 +1,19 @@
#!/bin/sh -e
root=$(git rev-parse --show-cdup 2>/dev/null) || \
{ echo "Not under git control. Cannot install git hooks." >&2 ; exit 0 ; }
dst="${root}"$(git rev-parse --git-path hooks/)
src=util/git-hooks/ # relative to root
hooks=$(cd "${root}${src}" && git ls-files -c | grep -Ev 'install.sh|wrapper.sh')
for h in $hooks; do
# Test if hook is not already installed, i.e. doesn't point at the wrapper
if [ ! "${dst}$h" -ef "${root}${src}wrapper.sh" ]; then
# preserve custom hooks if any
if [ -e "${dst}$h" ]; then
mv "${dst}$h" "${dst}$h.local"
fi
ln -s "$(git rev-parse --prefix $(git rev-parse --git-path hooks/) --show-cdup)${src}wrapper.sh" "${dst}$h"
fi
done

12
util/git-hooks/pre-applypatch Executable file
View File

@ -0,0 +1,12 @@
#!/bin/sh
#
# An example hook script to verify what is about to be committed
# by applypatch from an e-mail message.
#
# The hook should exit with non-zero status after issuing an
# appropriate message if it wants to stop the commit.
. git-sh-setup
test -x "$GIT_DIR/hooks/pre-commit" &&
exec "$GIT_DIR/hooks/pre-commit" ${1+"$@"}
:

9
util/git-hooks/pre-commit Executable file
View File

@ -0,0 +1,9 @@
#!/bin/sh
#
# A hook script to verify what is about to be committed.
# Called by "git commit" with no arguments. The hook should
# exit with non-zero status after issuing an appropriate message if
# it wants to stop the commit.
# Check for whitespace errors
git diff-index --check --cached HEAD -- || exit 1

74
util/git-hooks/pre-push Executable file
View File

@ -0,0 +1,74 @@
#!/bin/sh
# A hook script to verify what is about to be pushed. Called by "git
# push" after it has checked the remote status, but before anything has been
# pushed. If this script exits with a non-zero status nothing will be pushed.
#
# This hook is called with the following parameters:
#
# $1 -- Name of the remote to which the push is being done
# $2 -- URL to which the push is being done
#
# If pushing without using a named remote those arguments will be equal.
#
# Information about the commits which are being pushed is supplied as lines to
# the standard input in the form:
#
# <local ref> <local sha1> <remote ref> <remote sha1>
remote="$1"
url="$2"
zero=0000000000000000000000000000000000000000
upstream_pattern="github\.com.flashrom/flashrom(\.git)?|flashrom\.org.git/flashrom(\.git)?"
precious_branches="stable staging"
# Only care about the upstream repository
if echo "$url" | grep -q -v -E "$upstream_pattern" ; then
exit 0
fi
while read local_ref local_sha remote_ref remote_sha ; do
if [ "$remote_ref" != "refs/heads/staging" -a "$remote_ref" != "refs/heads/stable" ]; then
echo "Feature branches not allowed ($remote_ref)." >&2
exit 1
fi
if [ "$local_sha" = $zero ]; then
echo "Deletion of branches is prohibited." >&2
exit 1
fi
if [ "$remote_sha" = "$zero" ]; then
echo "No new branches allowed." >&2
exit 1
fi
# Check for Signed-off-by and Acked-by
commit=$(git rev-list -n 1 --all-match --invert-grep -E \
--grep '^Signed-off-by: .+ <.+@.+\..+>$' --grep '^Acked-by: .+ <.+@.+\..+>$' \
"$remote_sha..$local_sha")
if [ -n "$commit" ]; then
echo "Commit $local_sha in $local_ref is missing either \"Signed-off-by\"" \
" or \"Acked-by\" lines, not pushing." >&2
exit 1
fi
# Make _really_ sure we do not rewrite precious history
for lbranch in $precious_branches ; do
if [ "$remote_ref" = "refs/heads/$lbranch" ]; then
nonreachable=$(git rev-list $remote_sha ^$local_sha | head -1)
if [ -n "$nonreachable" ]; then
echo "Only fast-forward pushes are allowed on $lbranch." >&2
echo "$nonreachable is not included in $remote_sha while pushing to $remote_ref" >&2
exit 1
fi
fi
done
# FIXME: check commit log format (subject without full stop at the end etc).
# FIXME: do buildbot checks if authorized?
done
exit 0

10
util/git-hooks/wrapper.sh Executable file
View File

@ -0,0 +1,10 @@
#!/bin/sh
if [ -x $0.local ]; then
$0.local "$@" || exit $?
fi
hook=$(git rev-parse --show-toplevel)"/util/git-hooks/"$(basename $0)
if [ -x $hook ]; then
$hook "$@" || exit $?
fi